function get_trade_info(){
    console.log('aaaa')
    //
    var trade_url = $('#deals a').attr('href');
    //
    var trade_name = $('.page-wrapper h1').text();
    console.log('trade_name:'+trade_name);
    if (typeof trade_name === 'undefined' || trade_name == '') {
        trade_name = $('#online-header-left h1').text();
    }
    //
    var trade_date =    $('.page-wrapper .mb-0.fs-20 .ms-1').eq(0).text();
     if (typeof trade_date === 'undefined' || trade_date == '') {
        trade_date = $('#online-header-left .header_date span').eq(0).text();
    }
    //country
    var trade_address = $('.page-wrapper .mb-0.fs-20:last-child').text();
    console.log('trade_address:'+trade_address);
    if (typeof trade_address === 'undefined' || trade_address == '') {
        trade_address = $('#online-header-left .mt-1:last-child').text();
    }
    //about
    var trade_about = $('#exhib_profile p').text()
    //
    var trade_logo = $('.page-wrapper img.img-thumbnail').attr('src');
    if (typeof trade_logo === 'undefined') {
        trade_logo = ''
    }
    if (typeof trade_logo === 'undefined' || trade_logo == '') {
        trade_logo = $('#online-header-left img.img-thumbnail').attr('src');
    }
     if (typeof trade_logo === 'undefined') {
        trade_logo = ''
    }
    console.log('trade_about1:'+trade_about);
    if (typeof trade_about === 'undefined' || trade_about == '') {
        trade_about = $('.about .box.fs-14').eq(0).text()
    }
    if (typeof trade_about === 'undefined') {
        trade_about = ''
    }
    if (typeof trade_url === 'undefined') {
        trade_url = $('#visitors a').attr('href');
        if(trade_url){
            if(trade_url.indexOf('javascript') != -1){
                trade_url = $('#exhibitors a').attr('href');
            }
        }
        if (typeof trade_url === 'undefined') {
            trade_url = $('#exhibitors a').attr('href');
        }
    }

    console.log('trade_about:'+trade_about);
    var trader_info = {
        'trade_name':trade_name,
        'trade_url':trade_url,
        'trade_logo': trade_logo,
        'trade_date': trade_date,
        'trade_address':trade_address,
        'trade_about':trade_about
    };
    var res = {
        'items': [trader_info],
        'name': trade_name+'-exhibition'
    }
    return res;
}

function shangjia_localStorage_update(key='',data={}){
    localStorage[key] = JSON.stringify(data);
}

function get_trade_exhibitors(){
    var message = {
        action: 'can_zidong_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=> {
        console.log('can_zidong_caiji 答复', msg)
        let msgobj = JSON.parse(msg);
        console.log(msgobj['state']);
        if (msgobj['state'] == 0) { //可以采集
            console.log('采集已开启');
            var trade_url = $('#deals a').attr('href');
            if (typeof trade_url === 'undefined') {
                trade_url = $('#about a').attr('href');
            }
            if (typeof trade_url === 'undefined') {
                trade_url = $('#visitors a').attr('href');
            }
            var trade_name = $('.main-header h1').text();
            trade_name = trade_name.trim();
            //
            var current_trader_exhibitors = [];
            $('.exhibitorsBlock').each(function (){
                var enquiry_id = $(this).find("button.exhibitorEnquiry").attr('id');
                if(enquiry_id){
                    enquiry_id = enquiry_id.replace('enquiry-','');
                    current_trader_exhibitors.push(enquiry_id);
                }
            })
            //
            var eventID = $('#eventID').val();
            for(i=0;i<current_trader_exhibitors.length;i++){
                let storage_key = 'exhibitor_'+eventID+'_'+current_trader_exhibitors[i];
                let url = 'https://10times.com/ajax?for=exhibitorWeb&id='+eventID+'&exh_id='+current_trader_exhibitors[i];
                //去重并添加
                if(localStorage.getItem(storage_key) == null){
                    //
                    console.log('storage_key:'+storage_key+' add success');
                    //
                    shangjia_localStorage_update(storage_key,{
                        'url':url,
                        'trade_url':trade_url,
                        'trade_name':trade_name,
                        'name':'',
                        'website':'',
                        'products':'',
                        'country':'',
                        'profile':'',
                        'is_request':0,
                        's_time':0
                    });
                }
                //
            }
            //
        }else{
            console.log('前台采集已暂停');
        }
    });
}

function request_shangjia_ajax(key){
     let localStorage_value = localStorage.getItem(key);
     if(localStorage_value){
         let parsed_localStorage_value = JSON.parse(localStorage_value);
         $.ajax({
                 url: parsed_localStorage_value['url'],
                 timeout : 5000, //超时时间设置，单位毫秒
                 data: {},
                 type: 'GET',
                 async:true,
                 dataType: 'json',
                 contentType:'application/json;charset=utf-8',
                 success: function(data) {
                    console.log('fff');
                    //console.log(data);
                    if(data['status']['code'] == 1){
                        var trade_datas = data['data'];
                        for(var i=0;i<trade_datas.length;i++){
                             parsed_localStorage_value['name'] = trade_datas[i]['name'];
                             parsed_localStorage_value['website'] = trade_datas[i]['website'];
                             parsed_localStorage_value['products'] = trade_datas[i]['products'];
                             parsed_localStorage_value['country'] = trade_datas[i]['location']['countryName']+' , '+trade_datas[i]['location']['cityName'];
                             parsed_localStorage_value['profile'] = trade_datas[i]['company']['profile'];
                             parsed_localStorage_value['is_request'] = 2;
                             //
                             shangjia_localStorage_update(key, parsed_localStorage_value);
                             //
                        }
                    }
                 }
            });
     }
}

function request_shangjia(){
    var message = {
        action: 'can_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=> {
        console.log('can_caiji 答复', msg)
        let msgobj = JSON.parse(msg);
        console.log(msgobj['state']);
        if (msgobj['state'] == 0) { //可以采集
            console.log('采集已开启');
            //
            for (let i = 0; i < localStorage.length; i++) {
                let key = localStorage.key(i);
                //
                if(key.indexOf('exhibitor_') != -1){
                    let localStorage_value = localStorage.getItem(key);
                    let parsed_localStorage_value = JSON.parse(localStorage_value);
                    if(parsed_localStorage_value['is_request'] == 0 || (parsed_localStorage_value['is_request'] == 1 && parsed_localStorage_value['s_time'] < (Date.now()-10000))) {
                        parsed_localStorage_value['is_request'] = 1;
                        parsed_localStorage_value['s_time'] = Date.now();
                        shangjia_localStorage_update(key, parsed_localStorage_value);
                        request_shangjia_ajax(key);
                        break;
                    }
                }
                //
            }
            //
        }else{
            console.log('采集已暂停');
        }
    });
}

function extract_shangjia(){
    //
    var shangjia_infos = [];
    for (let i = 0; i < localStorage.length; i++) {
        let key = localStorage.key(i);
        //
        if (key.indexOf('exhibitor_') != -1) {
            let localStorage_value = localStorage.getItem(key);
            let parsed_localStorage_value = JSON.parse(localStorage_value);
            delete parsed_localStorage_value.s_time;
            delete parsed_localStorage_value.url;
            if(parsed_localStorage_value['is_request'] == 2){
                parsed_localStorage_value['is_request'] = '已完成';
            }else{
                parsed_localStorage_value['is_request'] = '未完成';
            }
            shangjia_infos.push(parsed_localStorage_value);
        }
    }
     var catalog_products = {
         'shangjia_infos': shangjia_infos
     }
    return catalog_products;
}

function shangjia_localStorage_log(){
    for (let i = 0; i < localStorage.length; i++) {
        let key = localStorage.key(i);
        //
        if (key.indexOf('exhibitor_') != -1) {
            let localStorage_value = localStorage.getItem(key);
            console.log('log key:'+key);
            console.log('log value:'+localStorage_value);
        }
    }
}

function shangjia_get_jindu_info(){
    let total = 0;
    let has_complete = 0;
    for (let i = 0; i < localStorage.length; i++) {
        let key = localStorage.key(i);
        //
        if (key.indexOf('exhibitor_') != -1) {
            total +=1;
            let localStorage_value = localStorage.getItem(key);
            let parsed_localStorage_value = JSON.parse(localStorage_value);
            if(parsed_localStorage_value['is_request'] == 2){
                has_complete +=1;
            }
        }
    }
    return {
        'total':total,
        'has_complete':has_complete
    }
}

function shangjia_send_topopup_jindu(){
    let jindu_data = shangjia_get_jindu_info();
    var message = {
        action: 'update-shangjia-num',
        info: '',
        data: jindu_data
    };
    send_message_to_popup(message);
}

function shangjia_clean(){
    for (let i = 0; i < localStorage.length; i++) {
        let key = localStorage.key(i);
        //
        if (key.indexOf('exhibitor_') != -1) {
           localStorage.removeItem(key);
        }
    }
}

function xintiao(){
 request_shangjia();
 shangjia_localStorage_log();
}
setInterval(xintiao, 15000);

function xintiao_topopup(){
 shangjia_send_topopup_jindu();
}
setInterval(xintiao_topopup, 5000);

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('exhibitorsNewDetail')!=-1 && performanceResourceItem['name'].indexOf('exhibitorsFilterData')!=-1){
                //console.log(performanceResourceItem['name']);
                //console.log('bbbb'+performanceResourceItem['name']);
                //
                get_trade_exhibitors();
            }
        }
    }
    //////
    performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }
}
var observer_ = new PerformanceObserver(perf_observer);
observer_.observe({entryTypes:['resource', 'navigation']});

$(document).ready(function () {
    let current_url = window.location.href;
    if(current_url && current_url.indexOf('exhibitors') !=-1) { //https://10times.com/cowboy-christmas-gift-show/exhibitors
        setTimeout(function() {
            get_trade_exhibitors();
            }, 1000);
    }
});

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract-exhibition') {
        //console.log(request.info);
        trade_info = get_trade_info();
        sendResponse(trade_info);
    }else if(request.action == 'extract-catalog-products-export-clean'){
        //console.log(request.info);
        trade_exhibitors_info = extract_shangjia();
        sendResponse(trade_exhibitors_info);
    }else if(request.action == 'shangjia_clean'){
        shangjia_clean();
    }
})

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}