function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_check_is_10times_page(){
    chrome.tabs.getSelected(null, function (tab) {
        var current_url =  tab.url;
        if(current_url){
            if(current_url.indexOf('10times')==-1){
                   chrome.tabs.create({ url: "https://10times.com/tradeshows/by-country" });
            }
        }else{
            chrome.tabs.create({ url: "https://10times.com/tradeshows/by-country" });
        }
    });
}

function get_expire(){
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            if(IS_TIEPAI){
                $('#message-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
            }else{
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_10times_1nian' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            }
            return;
        }else{
            console.log('expire_date');
            console.log(expire_date);
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                if(IS_TIEPAI){
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_10times_1nian' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                return;
            }
        }
    });
}

get_expire();

//
function jihuo(){
    $('#jihuo_btn').click(function (){
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-info').html('');
        if(jihuo_text==''){
            $('#message-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {
                        var bg = chrome.extension.getBackgroundPage();
                        bg.plugin_set_expire(expire_date,function (){
                            expire_date = expire_date.replace('T00:00:00.000Z','');
                            $('#expire_date').html(expire_date);
                            $('.jihuo').hide();
                            $('#message-account-info').html('');
                        });
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        if(IS_TIEPAI){
                            $('#message-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                        }else{
                            $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_10times_1nian' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        }
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();

function init(){
    if(IS_TIEPAI){
        $('.footer').remove();
        $('.tiepai_footer').show();
        $('body').css({'height':'220px'});
    }else{
        $('.footer').show();
        $('.tiepai_footer').remove();
    }
    var bg = chrome.extension.getBackgroundPage();
    bg.storage_get(function (callback_data) {
        if(callback_data.hasOwnProperty('pause') && callback_data['pause'] == 1){
            $('#extract-catalog-products-pause').text('采集已暂停,可点击开启');
        }else{
            $('#extract-catalog-products-pause').text('采集已开启,可点击暂停');
        }
        $('#extract-catalog-products-pause').show();
        //
        //前台采集
        if(callback_data['pause_page'] == 1){
            $('#extract-catalog-products-pause-page').text('已关闭前台采集,可点击开启');
        }else{
            $('#extract-catalog-products-pause-page').text('已开启前台采集,可点击暂停');
        }
        $('#extract-catalog-products-pause-page').show();
        //
    });
    //
}
init();

function extract_catalog_products_pause(){
    $('#extract-catalog-products-pause').click(function (){
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause'] == 1){
                    $('#extract-catalog-products-pause').text('采集已暂停,可点击开启');
                }else{
                    $('#extract-catalog-products-pause').text('采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause();

function extract_catalog_products_pause_page(){
    $('#extract-catalog-products-pause-page').click(function (){
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_page_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause_page'] == 1){
                    $('#extract-catalog-products-pause-page').text('已关闭前台采集,可点击开启');
                }else{
                    $('#extract-catalog-products-pause-page').text('已开启前台采集,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause_page();

function extract_catalog_products_export_clean(){
    $('#extract-catalog-products-export-clean').click(function (){
        //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let is_expire = false;
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                if(IS_TIEPAI){
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                }else{
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_10times_1nian' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                }
                is_expire = true;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    if(IS_TIEPAI){
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_10times_1nian' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    is_expire = true;
                }
            }
            //
            //
            // popup ---> content
            chrome.tabs.query({
                active: true,
                currentWindow: true
            }, (tabs) => {
                let message = {
                    action: 'extract-catalog-products-export-clean',
                    info: ''
                }
                chrome.tabs.sendMessage(tabs[0].id, message, res => {
                    console.log('popup=>content extract-catalog-products-export-clean')
                    //console.log(res)
                    let _shangjia_infos = res['shangjia_infos'];
                    if(!is_expire){
                        //
                        exportToExcel(_shangjia_infos, '10times-export-'+Date.now(), "Sheet1");
                        //
                    }else{
                        let _shangjia_infos_shiyong = _shangjia_infos;
                        if(_shangjia_infos.length > 10){
                            _shangjia_infos_shiyong = _shangjia_infos.slice(0,10);
                        }
                        //
                        exportToExcel(_shangjia_infos_shiyong, '10times-export-'+Date.now(), "Sheet1");
                        //
                        $('#message-info').html("<span style='color:red;'>提醒：试用版只能导出前10个！</span>");
                    }
                })
            })
        });
        //
    });
}
extract_catalog_products_export_clean();

function shangjia_clean(){
    $('#extract-catalog-products-clean').click(function (){
        if(confirm("确认清空吗?")){
            //
            $('#message-info').html('<span style="font-size: 12px;">清空需要花费些时间,正在清理...</span>')
            console.log('extract-catalog-products-url');
            //
            var bg = chrome.extension.getBackgroundPage();
            bg.storage_get(function (callback_data) {
                console.log('extract_catalog_products_export_clean');
                console.log(callback_data);
                //
                let expire_date = callback_data['expire'];
                if(typeof expire_date === 'undefined'){
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    if(IS_TIEPAI){
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                    }else{
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_10times_1nian' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    }
                    return;
                }else{
                    console.log('expire_date');
                    console.log(expire_date);
                    expire_date = expire_date.replace('T00:00:00.000Z','');
                    $('#expire_date').html(expire_date);
                    if (util_check_expire(expire_date)) {
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        if(IS_TIEPAI){
                            $('#message-info').html("<span style='color:red;'>已过期或未激活，联系客服！</span>");
                        }else{
                            $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_10times_1nian' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        }
                        return;
                    }
                }
                //
                //
                // popup ---> content
                chrome.tabs.query({
                    active: true,
                    currentWindow: true
                }, (tabs) => {
                    let message = {
                        action: 'shangjia_clean',
                        info: ''
                    }
                    chrome.tabs.sendMessage(tabs[0].id, message, res => {
                        console.log('popup=>shangjia_clean');
                        console.log(res);
                        $('#message-info').html('');
                    })
                })
            });
            //
        }
    });
}
shangjia_clean();
//从content接收信息
chrome.runtime.onMessage.addListener((req, send, sendRes) => {
    console.log("收到info:", req.info)
    console.log("收到action:", req.action)
    console.log("收到data:", req.data)

    if(req.action == 'update-shangjia-num'){
        var data = req.data;
        $('#data_process').html("已添加<span>"+data['total']+"</span>个参展商, 已采集<span>"+data['has_complete']+"</span>个");
    }

    //sendRes("popup已经收到")

  })
//

//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}

//
function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}
